Filter interviews by
Clear (1)
I was interviewed in Dec 2020.
Round duration - 60 minutes
Round difficulty - Medium
Hackerrank is a good paltform and very flexible, our webcam was turned on in order to prevent students from cheating
Your task is to identify the position of the only '1' bit in the binary representation of a given non-negative integer N
. The representation contains exactly one '1' and the rest are...
Find the position of the only '1' bit in the binary representation of a given non-negative integer.
Iterate through the bits of the integer to find the position of the lone '1' bit.
Use bitwise operations to check if there is exactly one '1' bit in the binary representation.
Return the position of the lone '1' bit or -1 if there isn't exactly one '1'.
You are provided with a number of stairs, and initially, you are located at the 0th stair. You need to reach the Nth stair, and you can climb one or tw...
The problem involves counting the number of distinct ways to climb N stairs by taking 1 or 2 steps at a time.
Use dynamic programming to solve the problem efficiently.
The number of ways to reach the Nth stair is the sum of the number of ways to reach the (N-1)th stair and the (N-2)th stair.
Handle base cases where N=0 and N=1 separately.
Consider using modulo operation to avoid overflow when dealing with large numbers.
Round duration - 40 minutes
Round difficulty - Hard
Round was conducted on zoom platform. There were 40 students there and then each one of them were assigned break-out rroms for interviews.
Tip 1 : try to keep only those things in resume on which you have very good command and you should be able to answer all of the questions(upto moderate level) related to your technical skills
Tip 2 : mention your projects with brief description, try avoiding very high level description because some times reader might not be able to understand your work, keep it descriptive and understandable
Tip 1 : major team project is helpful
Tip 2 : list down only the related achievements with the role you are applying for
I was interviewed before Sep 2020.
Round duration - 150 Minutes
Round difficulty - Medium
This first round was the Online test which was 1 Hour 95 Minutes Long. It was Divided
as Follows.
1. Aptitude Section (Arithmetic + Analytical) 14 Questions – 26 Minutes
2. Technical MCQs( Computer Science) 14 Questions – 19 Minutes
3. Coding Question – 20 Minutes
4. Coding Question – 30 Minutes
5. Coding Questions :
You are provided with an array ARR
of positive integers. Each integer represents the number of liters of water in a bucket. The goal is to make the liters of water in ...
Given an array of water buckets, find the minimum liters of water to remove to make all buckets equal.
Iterate through the array to find the most common water level
Calculate the total liters needed to make all buckets equal by subtracting each bucket's water level from the most common level
Sum up the total liters needed to remove
Given two arrays/lists A
and B
, each of size N
, and an integer K
, you need to determine the K
maximum and valid sum combinations from all possible combinations of ...
The problem involves finding the K maximum sum combinations from two arrays by adding one element from each array.
Iterate through all possible sum combinations of elements from arrays A and B.
Store the sums in a max heap to keep track of the K maximum sums.
Pop the top K elements from the max heap to get the K maximum sum combinations.
Round duration - 150 Minutes
Round difficulty - Medium
This was an Online F2F Technical Round conducted on CodePair : Hackerrank. So, Basically You have to Run and Submit ( Pass All Test cases) in the Interview Round also (Like normal Coding Test) in Codepair: Hackerrank & along with that You should have to explain your Code and Approach to the Interviewers.
In this problem, you have a one-dimensional garden of length 'N'. Each position from 0 to 'N' has a fountain that can provide water to the garden up to a certain range...
Find the minimum number of fountains to activate to water the entire garden.
Iterate through the array to find the coverage of each fountain.
Keep track of the farthest coverage reached by each activated fountain.
Activate the fountain that covers the farthest distance not yet covered.
Repeat until the entire garden is watered.
Round duration - 150 Minutes
Round difficulty - Medium
This was also an Online F2F Technical Round conducted on Codepair : Hackerrank.
Dynamic Programming Based Not So Easy Level:
Best Time to Buy and Sell Stock
Best Time to Buy and Sell Stock II
Dynamic Programming Based Not So Medium Level
Best Time to Buy and Sell Stock with Cooldown
Best Time to Buy and Sell Stock with Transaction Fee
Dynamic Programming Based Hard Level
Best Time to Buy and Sell Stock III
Best Time to Buy and Sell Stock IV
They asked me a Lot of Questions like:
How did you arrive at this Solution ?
Why is this Approach Right ?
Can You do this in Better time & space complexities ? (Although I have done in Best time Complexity but they asked this to check my confidence level on my codes).
A lot of Variants based on Constraints.
You are given an array 'PRICES' of 'N' integers, where 'PRICES[i]' represents the price of a certain stock on the i-th day. An integer 'K' is also provide...
The task is to determine the maximum profit achievable with at most K transactions by buying and selling stocks.
Iterate through the array and keep track of the minimum price to buy and maximum profit for each transaction.
Use dynamic programming to store the maximum profit at each day with each possible number of transactions.
Consider edge cases like when K is 0 or when the array is empty.
Example: For input N = 6, PRICE...
Imagine you are Harshad Mehta's friend, and you have been given the stock prices of a particular company for the next 'N' days. You can perform up to two buy-and-sell ...
The task is to determine the maximum profit that can be achieved by performing up to two buy-and-sell transactions on a given set of stock prices.
Iterate through the array of stock prices and calculate the maximum profit that can be achieved by buying and selling at different points.
Keep track of the maximum profit after the first transaction and the maximum profit overall by considering different combinations of buy a...
Tip 1 : Solve atleast 300 coding questions.
Tip 2 : Have some good projects on resume.
Tip 3 : Be truthful.
Tip 1 : Have 2 or 3 good projects.
Tip 2 : Don't lie on your resume.
I was interviewed before Sep 2020.
Round duration - 80 minutes
Round difficulty - Easy
This round was scheduled in the evening hours around 7pm at Hackerrank platform and all the participants were required to fill a form which was shared 2 days prior to the test date. This form was filled out probably for the security reasons and to ensure that no one disinterested participant gives the test.
Given an infinite supply of coins of varying denominations, determine the total number of ways to make change for a specified value using these coins. If it's not possible to make...
The task is to find the total number of ways to make change for a specified value using given denominations.
Use dynamic programming to solve this problem efficiently.
Create a 2D array to store the number of ways to make change for each value up to the specified value.
Iterate through each denomination and update the array accordingly.
The final answer will be stored in the last cell of the array.
Example: For N=3, D=[1, 2...
Given an integer array 'ARR' of size 'N' containing numbers from 0 to (N - 2). Each number appears at least once, and there is one number that appears twice. Yo...
Find the duplicate number in an array of integers from 0 to (N-2).
Iterate through the array and keep track of the count of each number using a hashmap.
Return the number with a count greater than 1 as the duplicate number.
Alternatively, use Floyd's Tortoise and Hare algorithm to find the duplicate number in O(N) time and O(1) space.
Round duration - 45 minutes
Round difficulty - Hard
This round was conducted on Zoom platform. I was shared the invitation link one day prior to the interview and also was told the name of my interviewer. I looked at the profile of the interviewer at linked.in and got a better understanding of what kind of person he was and prepared accordingly. The round was scheduled at 3 :00 pm on 20th August and I was eagerly waiting for the clock hands to reach 3 o'clock since morning and finally I went in front of him after wearing a white shirt and a black coat over it along with a tie over it.
Given an array of integers 'ARR' and an integer 'K', determine the first negative integer in every contiguous subarray (or window) of size 'K'. If a window...
Find the first negative integer in every window of size K in an array.
Iterate through the array using a sliding window approach of size K
For each window, find the first negative integer and add it to the result array
If no negative integer is found in a window, add 0 to the result array
Tip 1 : Practice all DSA questions from interview bit
Tip 2 : Do Atleast 3 project one should be major, if it's in web dev it would be beneficial.
Tip 3 : Should be good in communication skills
Tip 1 : resume should be short and descriptive
Tip 2 : mention all the important projects that you have worked on
Tip 3 : better if resume is enclosed in single page
I was interviewed before Sep 2020.
Round duration - 75 minutes
Round difficulty - Hard
This was a pure coding round consisting of three questions where time allotted for one easy question was 15 minutes while the other two questions were to solved in 30 minutes each.
total time = 15+30+30= 75 minutes
Develop a program to determine the number of '1's in the binary form of a given integer.
The input consists of a single line containing an integer N.
The outpu...
Develop a program to count the number of '1's in the binary form of a given integer.
Convert the given integer to its binary representation
Count the number of '1's in the binary representation
Return the count of '1's as the output
Handle constraints such as input range
Given 'N' students standing in a row with specific heights, your task is to find the length of the longest strictly increasing subsequence of their heights...
Find the length of the longest strictly increasing subsequence of heights of students in a row.
Iterate through the heights array and for each student, find the length of the longest increasing subsequence ending at that student.
Use dynamic programming to keep track of the longest increasing subsequence length for each student.
Return the maximum length found in the dynamic programming array as the result.
Example: For he...
Round duration - 45 minutes
Round difficulty - Hard
There were 2 interviewers and the round was carried out on code pair platform of HackerRank
Prateek, a kindergarten teacher, needs to distribute candies to his class. Each child has a performance grade, and all students stand in a line.
The rules for distrib...
Calculate the minimum number of candies needed to distribute to students based on their performance grades.
Create an array to store the minimum candies needed for each student.
Iterate through the students' ratings from left to right, comparing each student with the previous one to determine the candy count.
Iterate through the students' ratings from right to left, comparing each student with the next one to ensure the c...
Tip 1 : Single page resume but brief
Tip 2 : Major team product is must
Tip 3 : Regular coding practice on GFG, Leetcode and coding ninjas type platforms
Tip 1 : Consists the brief of your skill set
Tip 2 : Github link of projects should be provided
Tip 3 : Mention clearly if you have done a team project
DE Shaw interview questions for designations
I was interviewed before Sep 2020.
Round duration - 75 minutes
Round difficulty - Medium
2 coding questions
Given a binary tree with 'N' nodes, verify whether this tree is a Binary Search Tree (BST). Return true if it is a BST and false otherwise.
A Binary Search ...
Verify if a given binary tree is a Binary Search Tree (BST) or not.
Check if the left subtree of a node contains only nodes with values less than the node's value.
Check if the right subtree of a node contains only nodes with values greater than the node's value.
Ensure that both the left and right subtrees are also binary search trees.
Return true if the tree is a BST, false otherwise.
Handle cases with duplicate elements
Given a singly linked list of integers, return the head of the reversed linked list.
Initial linked list: 1 -> 2 -> 3 -> 4 -> NULL
Reversed link...
Reverse a singly linked list of integers and return the head of the reversed linked list.
Iterate through the linked list and reverse the pointers to point to the previous node instead of the next node.
Use three pointers to keep track of the current, previous, and next nodes while reversing the linked list.
Update the head of the reversed linked list as the last node encountered during the reversal process.
Round duration - 45 minutes
Round difficulty - Medium
Given a binary tree with N
nodes, determine whether the tree is a Binary Search Tree (BST). If it is a BST, return true
; otherwise, return false
.
A binary search tree (BST)...
Validate if a binary tree is a Binary Search Tree (BST) or not.
Check if the left subtree of a node contains only nodes with data less than the node's data.
Check if the right subtree of a node contains only nodes with data greater than the node's data.
Ensure that both the left and right subtrees are also binary search trees.
Traverse the tree in an inorder manner and check if the elements are in sorted order.
Use recursio
Tip 1 : Practice more.
Tip 2 : Solve questions on Coding ninjas and Leetcode.
Tip 3 : Make good projects.
Tip 1 : Keep it short.
Tip 2 : Mention your projects in brief.
Get interview-ready with Top DE Shaw Interview Questions
I was interviewed before Sep 2020.
Round duration - 75 minutes
Round difficulty - Easy
Smooth platform of Hackerrank.
Nice user interface.
Given a singly linked list of integers, return the head of the reversed linked list.
Initial linked list: 1 -> 2 -> 3 -> 4 -> NULL
Reversed link...
Reverse a singly linked list of integers and return the head of the reversed linked list.
Iterate through the linked list and reverse the pointers to point to the previous node.
Update the head of the reversed linked list as the last node encountered.
Ensure to handle edge cases like empty list or single node list.
Time complexity should be O(N) and space complexity should be O(1).
Tip 1 : Do at-least 2 projects.
Tip 2 : Practice on coding ninjas.
Tip 1 : Mention if you have any experience in past.
Tip 2 : Put your competitive profiles URL.
I was interviewed before Sep 2020.
Round duration - 90 minutes
Round difficulty - Medium
It was conducted in the evening at around 7:00 p.m.
The hackerrank environment is clearly the best for conducting coding exams as it provides a decent interface for debugging and testing purposes.
There were 3 questions- 1 of easy level and 2 of medium level.
Determine if an array contains a Pythagorean triplet by checking whether there are three integers x, y, and z such that x2 + y2 = z2 within the array.
The first lin...
Detect if an array contains a Pythagorean triplet by checking if x^2 + y^2 = z^2.
Iterate through all possible triplets of numbers in the array and check if they form a Pythagorean triplet.
Use a nested loop to generate all possible combinations of three numbers from the array.
Check if the sum of squares of two numbers is equal to the square of the third number.
You are given 'a' balls of type 'A', 'b' balls of type 'B', and 'c' balls of type 'C'. Determine the total number of ways to arrange these balls in a straight line so that no...
The problem involves arranging balls of different types in a straight line without having two adjacent balls of the same type.
Use recursion to try all possible arrangements while keeping track of the previous ball type.
Handle edge cases where one or more types of balls have a count of 0.
Consider using dynamic programming to optimize the solution by storing intermediate results.
For the given example input (2 1 1), the o...
Given three strings A, B, and C, the task is to determine the length of the longest common subsequence across these three strings.
A subsequence ...
Find the length of the longest common subsequence among three strings.
Use dynamic programming to solve this problem efficiently.
Create a 3D array to store the lengths of common subsequences.
Iterate through the strings to fill the array and find the longest common subsequence length.
Round duration - 60 minutes
Round difficulty - Easy
The round was conducted on CodePair platform which provides a IDE along with a video call for interviews.
There were 2 interviewers and both were friendly.
I was first asked about the various subjects I have studied in my curriculum. Then I was asked about my favourite programming language to which I answered Python.
After this, they asked various confusing questions based on function calling, argument passing and pass by object reference concept in Python.
Then they asked about the implementation of dictionary in Python and wanted me to design one with the help of lists(arrays) and optimize its search, add and delete operations. (Could be done with hashing and probing).
Then they asked questions from subjects like Computer Architecture and Theory of Computation (Basic questions were asked so you should just remember the key topics in the subject).
You are provided with a linked list of integers. Your task is to implement a function that deletes a node located at a specified position 'POS'.
The first line co...
Implement a function to delete a node from a linked list at a specified position.
Traverse the linked list to find the node at the specified position.
Update the pointers of the previous and next nodes to skip the node to be deleted.
Handle cases where the position is at the beginning or end of the linked list.
Ensure to free the memory of the deleted node to avoid memory leaks.
Tip 1 : For an intern position in any big company, the most important thing is practicing data structures. Solve as many questions as you can on platforms like Coding Ninjas. First start picking up questions topic-wise and once you gain a decent confidence in every topic, start hitting harder questions randomly on various platforms. (Practice a minimum of 300 questions).
Tip 2 : If you are stuck at solving any question, instead of looking up for a code solution try to read discussions and see various approaches people are applying. This will surely make you prepared for the way in which the interviews are designed. Always keep a clock ticking while solving a problem as spending too much time while practicing surely makes you slow in the Online Tests and Interviews.
Tip 3 : Again specifically for internship preparation, focus mainly on the subjects that have been taught to you till now. As in many colleges Database Management, Operating Systems and Computer Networks are not taught till the 4th semester so you could easily focus on subjects in your curriculum. OOPS concepts are very important!
Tip 1 : In On-Campus internship drives it is generally not required to have a very charming resume with a load of projects as the companies understand the candidate as a 4th semester student.
Tip 2 : But still if there is even a single decent project genuinely build by the student then it is more than sufficient.
I was interviewed before Sep 2020.
Round duration - 75 minutes
Round difficulty - Hard
It was a coding round on Hackerrank.
Given a binary tree with N
nodes, determine whether the tree is a Binary Search Tree (BST). If it is a BST, return true
; otherwise, return false
.
A binary search tree (BST)...
Validate if a binary tree is a Binary Search Tree (BST) based on given properties.
Check if the left subtree of a node contains only nodes with data less than the node's data.
Verify if the right subtree of a node contains only nodes with data greater than the node's data.
Ensure that both the left and right subtrees are also binary search trees.
Traverse the tree in level order form and compare the elements to validate if
Given a singly linked list of integers, return the head of the reversed linked list.
Initial linked list: 1 -> 2 -> 3 -> 4 -> NULL
Reversed link...
Reverse a singly linked list of integers and return the head of the reversed linked list.
Iterate through the linked list and reverse the pointers to create the reversed linked list.
Use three pointers to keep track of the current, previous, and next nodes while reversing the linked list.
Ensure to update the head of the reversed linked list at the end.
Example: Input: 1 -> 2 -> 3 -> 4 -> NULL, Output: 4 ->
Tip 1 : Practice on gfg
Tip 2 : Compete on codechef
Tip 3 : Learn DSA
Tip 1 : Mention all projects
Tip 2 : Don't write anything that you don't know
I was interviewed before Apr 2021.
Round duration - 90 Minutes
Round difficulty - Medium
This round had 3 coding questions to be solved under 90 minutes. I found the questions to be of Easy to Medium level of difficulty and anyone who has practised enough from LeetCode or CodeStudio would be able to pass this round.
You are provided with a number of stairs, and initially, you are located at the 0th stair. You need to reach the Nth stair, and you can climb one or tw...
The problem involves finding the number of distinct ways to climb N stairs by taking 1 or 2 steps at a time.
Use dynamic programming to solve the problem efficiently.
The number of ways to reach the Nth stair is the sum of the number of ways to reach the (N-1)th stair and the (N-2)th stair.
Handle base cases for N=0 and N=1 separately.
Apply modulo operation to avoid overflow while calculating the result.
Consider using mem...
You are provided with an array ARR
of positive integers. Each integer represents the number of liters of water in a bucket. The goal is to make the liters of water in ...
Given an array of water buckets, find the minimum liters of water to remove to make all buckets equal.
Iterate through the array to find the maximum frequency of a water amount
Calculate the total liters to be removed by subtracting the maximum frequency from the total number of buckets
Return the total liters to be removed as the answer
Develop a program to determine the number of '1's in the binary form of a given integer.
The input consists of a single line containing an integer N.
The outpu...
Count the number of '1's in the binary form of a given integer.
Convert the given integer to binary representation
Count the number of '1's in the binary representation
Return the count of '1's as output
Round duration - 60 Minutes
Round difficulty - Medium
In this round, the interviewer asked me 2 coding questions in which I was expected to first explain my approach with proper complexity analysis and then code up the solution. These questions were then followed by 2 puzzles to check my overall aptitude.
Prateek is a kindergarten teacher with a mission to distribute candies to students based on their performance. Each student must get at least one candy, and if two s...
The task is to distribute candies to students based on their performance while minimizing the total candies distributed.
Create an array to store the minimum candies required for each student.
Iterate through the students' ratings array to determine the minimum candies needed based on the adjacent ratings.
Consider both left-to-right and right-to-left passes to ensure fair distribution.
Calculate the total candies required...
You are given a binary tree with 'N' integer nodes. Your task is to determine whether this binary tree is a Binary Search Tree (BST).
A Binary Search Tr...
Validate if a given binary tree is a Binary Search Tree (BST) or not.
Check if the left subtree of a node contains only nodes with data less than the node's data
Check if the right subtree of a node contains only nodes with data greater than the node's data
Recursively check if both left and right subtrees are also binary search trees
Round duration - 30 Minutes
Round difficulty - Easy
This was a Technical Cum HR round where I was first asked some basic SQL related concepts and then we discussed
about my expectations from the company , learnings and growth in the forthcomig years. I would suggest be honest and
try to communicate your thoughts properly in these type of rounds to maximise your chances of getting selected.
Tip 1 : Must do Previously asked Interview as well as Online Test Questions.
Tip 2 : Go through all the previous interview experiences from Codestudio and Leetcode.
Tip 3 : Do at-least 2 good projects and you must know every bit of them.
Tip 1 : Have at-least 2 good projects explained in short with all important points covered.
Tip 2 : Every skill must be mentioned.
Tip 3 : Focus on skills, projects and experiences more.
I was interviewed before Sep 2020.
Round duration - 95 Minutes
Round difficulty - Easy
The complete test was Audio and Video Proctored.
The test was divided into 3 sections:
1) Aptitude: (14 MCQs in 28 minutes)
2) Technical: (12 MCQs in 17 minutes)
3) coding: (2 questions - first in 20 minutes, second in 30 minutes)
You are provided with an array, ARR
, of positive integers. Each integer represents the number of liters of water in a bucket. The goal is to make the water volume in each bucket ...
Find the minimum amount of water to be removed to equalize water in buckets.
Iterate through the array to find the average water level.
Calculate the total amount of water that needs to be removed to equalize the buckets.
Keep track of the excess water in each bucket and sum them up to get the final result.
You are given a binary tree consisting of 'N' unique nodes and a start node where the burning will commence. The task is to calculate the time in minutes required to completely b...
Calculate the time in minutes required to completely burn a binary tree starting from a given node.
Start burning from the given node and spread fire to adjacent nodes each minute
Track the time taken for each node to burn and return the maximum time taken
Use a queue to keep track of nodes to be burned next
Tip 1 : Strengthen DSA skills initially, know the basics and understand the working of different data structures
Tip 2 : Solve atleast 300 Questions from websites like leetcode and Hackerrank
Tip 3 : Learn to implement them and enhance your coding skills. Make mistakes and learn from them instead of just cramming everything before practicing.
Tip 4 : To enhance coding skills, try your best to crack a question instead of giving up and looking at the solution..this will improve your problem-solving skills.
Tip 5 : It's a must to do the standard coding questions under every category of data structure and algorithms
Tip 6 : To study the topics and practice coding questions refer to GeeksforGeeks and regularly take part in coding contests.
Tip 7 : Be thorough with OOPs, DBMS, and the technologies on which you have worked for the interview.
Tip 8 : Have at least 2 projects in your resume and make sure you can answer the questions related to them.
Tip 9 : For HR interviews prepare questions, prepare questions such as introduce yourself, your strengths, your weakness.
Confidence is the key you need to be an expert in. I was not aware of some things the interviewer asked during my interviews. But due to my confidence, he skipped that part.
Tip 10 : Do all the questions from the book 'cracking the coding interview'
Tip 1 : Make sure your resume fits everything into a single page.
Tip 2 : Have at least 2 projects on your resume.
Tip 3 : Only Mention only those technical skills that you are confident in. Do not put false things on your resume.
Tip 4 : Mention the work you have done during your internships.
Tip 5 : Include an objective in your resume.
Top trending discussions
Analyst
165
salaries
| ₹0 L/yr - ₹0 L/yr |
Senior Analyst
146
salaries
| ₹0 L/yr - ₹0 L/yr |
Manager
73
salaries
| ₹0 L/yr - ₹0 L/yr |
Project Lead
53
salaries
| ₹0 L/yr - ₹0 L/yr |
Member Technical Staff
48
salaries
| ₹0 L/yr - ₹0 L/yr |
Goldman Sachs
Morgan Stanley
Citadel
Blackrock